/*
 *  linux/init/version.c
 *
 *  Copyright (C) 1992  Theodore Ts'o
 *
 *  May be freely distributed as part of Linux.
 */

#include <linux/compile.h>
#include <linux/module.h>
#include <linux/uts.h>
#include <linux/utsname.h>
#include <linux/utsrelease.h>
#include <linux/version.h>
#include <linux/sched.h>

#define version(a) Version_ ## a
#define version_string(a) version(a)

int version_string(LINUX_VERSION_CODE);

struct uts_namespace init_uts_ns = {
	.kref = {
		.refcount	= ATOMIC_INIT(2),
	},
	.name = {
		.sysname	= UTS_SYSNAME,
		.nodename	= UTS_NODENAME,
		.release	= UTS_RELEASE,
		.version	= UTS_VERSION,
		.machine	= UTS_MACHINE,
		.domainname	= UTS_DOMAINNAME,
	},
};
EXPORT_SYMBOL_GPL(init_uts_ns);

const char wolk_banner[] =
	"WOLK - Working Overloaded Linux Kernel - v5.0 - Production Edition""\n\n";

const char linux_banner[] =
	"Linux version " UTS_RELEASE
#ifdef LINUX_COMPILE_DISTRIBUTION_OFFICIAL_BUILD
	" (" LINUX_COMPILE_DISTRIBUTION " "
	     LINUX_COMPILE_DISTRIBUTION_VERSION ")"
	" (" LINUX_COMPILE_DISTRIBUTION_UPLOADER ")"
#else
# ifdef LINUX_COMPILE_DISTRIBUTION_VERSION
	" (" LINUX_COMPILE_DISTRIBUTION_VERSION ")"
# endif
	" (" LINUX_COMPILE_BY "@" LINUX_COMPILE_HOST ")"
#endif
	" (" LINUX_COMPILER ")"
	" " UTS_VERSION "\n";

const char linux_proc_banner[] =
	"%s version %s"
#ifdef LINUX_COMPILE_DISTRIBUTION_OFFICIAL_BUILD
	" (" LINUX_COMPILE_DISTRIBUTION " "
	     LINUX_COMPILE_DISTRIBUTION_VERSION ")"
	" (" LINUX_COMPILE_DISTRIBUTION_UPLOADER ")"
#else
# ifdef LINUX_COMPILE_DISTRIBUTION_VERSION
	" (" LINUX_COMPILE_DISTRIBUTION_VERSION ")"
# endif
	" (" LINUX_COMPILE_BY "@" LINUX_COMPILE_HOST ")"
#endif
	" (" LINUX_COMPILER ") %s\n";
